---
title: XML introduction
slug: Web/XML/XML_introduction
tags:
  - Beginner
  - Introduction
  - NeedsContent
  - XML
---
<p><span class="seoSummary">XML (Extensible Markup Language) is a markup language similar to {{Glossary("HTML")}}, but without predefined tags to use. Instead, you define your own tags designed specifically for your needs. This is a powerful way to store data in a format that can be stored, searched, and shared.</span> Most importantly, since the fundamental format of XML is standardized, if you share or transmit XML across systems or platforms, either locally or over the internet, the recipient can still parse the data due to the standardized XML syntax.</p>

<p>There are many languages based on XML, including <a href="/en-US/docs/Glossary/XHTML" title="en/XHTML">XHTML</a>, <a href="/en-US/docs/Web/MathML" title="en/MathML">MathML</a>, <a href="/en-US/docs/Web/SVG" title="en/SVG">SVG</a>, <a href="/en-US/docs/Mozilla/Tech/XUL" title="en/XUL">XUL</a>, <a href="/en-US/docs/Mozilla/Tech/XBL" title="en/XBL">XBL</a>, <a href="/en-US/docs/Web/RSS" title="en/RSS">RSS</a>, and <a href="/en-US/docs/Web/RDF" title="en/RDF">RDF</a>. You can also define your own.</p>

<h2 id="Structure_of_an_XML_document">Structure of an XML document</h2>

<div class="notecard warning">
<p>This sub-article in process writing...</p>
</div>

<p>Whole structure XML and XML based languages built on {{Glossary("tag")}}s.</p>

<h3 id="XML_declaration">XML declaration</h3>

<p>XML - declaration is not a tag. It is used for the transmission of the meta-data of a document.</p>

<pre class="syntaxbox">&lt;?xml version="1.0" encoding="UTF-8"?&gt;</pre>

<h4 id="Attributes">Attributes:</h4>

<dl>
	<dt>version <span style="display: none;"> </span>:</dt>
	<dd>Used version XML in this document.</dd>
	<dt>encoding :</dt>
	<dd>Used encoding in this document.</dd>
</dl>

<h3 id="Comments">Comments</h3>

<pre class="syntaxbox">&lt;!-- Comment --&gt;</pre>

<h2 id="Correct_XML_valid_and_well-formed">"Correct" XML (valid and well-formed)</h2>

<h3 id="Сorrect_design_rules">Сorrect design rules</h3>

<p>For an XML document to be correct, the following conditions must be fulfilled:</p>

<ul>
	<li>Document must be well-formed.</li>
	<li>Document must conform to all XML syntax rules.</li>
	<li>Document must conform to semantic rules, which are usually set in an XML schema or a DTD (<strong><a href="/en-US/docs/Glossary/DTD" title="en/DTD">Document Type Definition</a>)</strong>.</li>
</ul>

<h3 id="Example">Example</h3>

<pre class="brush: xml">&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;message&gt;
    &lt;warning&gt;
        Hello World
    &lt;!--missing &lt;/warning&gt; --&gt;
&lt;/message&gt;
</pre>

<p>Now let's look at a corrected version of that same document:</p>

<pre class="brush: xml">&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;message&gt;
    &lt;warning&gt;
         Hello World
    &lt;/warning&gt;
&lt;/message&gt;
</pre>

<p>A document that contains an undefined tag is invalid. For example, if we never defined the <code>&lt;warning&gt;</code> tag, the document above wouldn't be valid.</p>

<div class="note">
<p>Most browsers offer a debugger that can identify poorly-formed XML documents.</p>
</div>

<h2 id="Entities">Entities</h2>

<p>Like HTML, XML offers methods (called entities) for referring to some special reserved characters (such as a greater than sign which is used for tags). There are five of these characters that you should know:</p>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Entity</th>
			<th scope="col">Character</th>
			<th scope="col">Description</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>&amp;lt;</td>
			<td>&lt;</td>
			<td>Less than sign</td>
		</tr>
		<tr>
			<td>&amp;gt;</td>
			<td>&gt;</td>
			<td>Greater than sign</td>
		</tr>
		<tr>
			<td>&amp;amp;</td>
			<td>&amp;</td>
			<td>Ampersand</td>
		</tr>
		<tr>
			<td>&amp;quot;</td>
			<td>"</td>
			<td>One double-quotation mark</td>
		</tr>
		<tr>
			<td>&amp;apos;</td>
			<td>'</td>
			<td>One apostrophe (or single-quotation mark)</td>
		</tr>
	</tbody>
</table>

<p>Even though there are only 5 declared entities, more can be added using the document's <a href="/en-US/docs/Glossary/DTD" title="en/DTD">Document Type Definition</a>. For example, to create a new <code>&amp;warning;</code> entity, you can do this:</p>

<pre>&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;!DOCTYPE body [
  &lt;!ENTITY warning "Warning: Something bad happened... please refresh and try again."&gt;
]&gt;
&lt;body&gt;
  &lt;message&gt; &amp;warning; &lt;/message&gt;
&lt;/body&gt;
</pre>

<p>You can also use numeric character references to specify special characters; for example, &amp;#xA9; is the "©" symbol.</p>

<h2 id="Displaying_XML">Displaying XML</h2>

<p>XML is usually used for descriptive purposes, but there are ways to display XML data. If you don't define a specific way for the XML to be rendered, the raw XML is displayed in the browser.</p>

<p>One way to style XML output is to specify <a href="/en-US/docs/Web/CSS" title="en/CSS">CSS</a> to apply to the document using the <code>xml-stylesheet</code> processing instruction.</p>

<pre>&lt;?xml-stylesheet type="text/css" href="stylesheet.css"?&gt;</pre>

<p>There is also another more powerful way to display XML: the <strong>Extensible Stylesheet Language Transformations</strong> (<a href="/en-US/docs/Web/XSLT" title="en/XSLT">XSLT</a>) which can be used to transform XML into other languages such as HTML. This makes XML incredibly versatile.</p>

<pre>&lt;?xml-stylesheet type="text/xsl" href="transform.xsl"?&gt;</pre>

<h2 id="Recommendations">Recommendations</h2>

<p>This article is obviously only a very brief introduction to what XML is, with a few small examples and references to get you started. For more details about XML, you should look around on the Web for more in-depth articles.</p>

<p>Learning the HyperText Markup Language (<a href="/en-US/docs/Web/HTML" title="en/HTML">HTML</a>) will help you better understand XML.</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a class="external" href="http://www.xml.com/">XML.com</a></li>
	<li><a class="external" href="https://www.w3.org/XML/">Extensible Markup Language (XML) @ W3.org</a></li>
	<li><a class="external" href="http://www.alistapart.com/d/usingxml/xml_uses_a.html">XML Example: A List Apart</a></li>
	<li><a class="external" href="http://www.alistapart.com/articles/usingxml/">Using XML: A List Apart</a></li>
</ul>

<p>The <a href="http://www.alistapart.com/articles/usingxml/">Using XML</a> article above is a great resource on information for transforming and creating your own language.</p>
